/*
   This program demonstrates parameterized sorting of lists in Language_10.
*/

public class Language_9_Examples_2
{
   public static void main(String[] args)
   {
      // IMPORTANT: Set this to 0 or 1 depending on whether you need
      // to see all of the interpreter's debugging information.
      Evaluate.DEBUG = 0;

      String[] programs =
      {
         "(prog" +
            "(fun sort" +
               "(lambda lst cmp" +
                  "(begin" +
                     "(fun insert" +
                        "(lambda x lst" +
                           "(if (empty lst)" +
                                "(cons x lst)" +
                                "(if (apply cmp x (car lst))" +
                                     "(cons x lst)" +
                                     "(cons (car lst) (apply insert x (cdr lst)))))))" +
                     "(fun nestedSort" +
                        "(lambda lst" +
                           "(if (empty lst)" +
                                "lst" +
                                "(apply insert (car lst) (apply nestedSort (cdr lst))))))" +
                     "(apply nestedSort lst))))" +
            "(apply sort (list 9 1 8 2 7 3 6 4 5) (lambda x y (< x y))))",


         "(prog" +
            "(fun sort" +
               "(lambda lst cmp" +
                  "(begin" +
                     "(fun insert" +
                        "(lambda x lst" +
                           "(if (empty lst)" +
                                "(cons x lst)" +
                                "(if (apply cmp x (car lst))" +
                                     "(cons x lst)" +
                                     "(cons (car lst) (apply insert x (cdr lst)))))))" +
                     "(fun nestedSort" +
                        "(lambda lst" +
                           "(if (empty lst)" +
                                "lst" +
                                "(apply insert (car lst) (apply nestedSort (cdr lst))))))" +
                     "(apply nestedSort lst))))" +
            "(fun makeCmp" +
               "(lambda fn selector" +
                  "(lambda t1 t2" +
                     "(apply fn (apply selector t1) (apply selector t2)))))" +
            "(fun selector (lambda triple (car (cdr triple))))" +
            "(var triples (list (list 1 2 3) (list 8 7 6) (list 4 5 6) (list 5 6 7)))" +
            "(apply sort triples (apply makeCmp (lambda x y (< x y)) selector)))"
      };


      for (int i = 0; i < programs.length; i++)
      {
         System.out.println(i + " =========================================");

         // Build and evaluate the AST that represents the expression.
         try
         {
            final Tree ast = ParseTree.buildTree( programs[i] );

            // Print the AST as an S-expression
            //System.out.println( ast + "\n" );

            // Pretty-print the abstract syntax tree.
            //System.out.println( PrettyPrinter.prettyPrint( ast ) + "\n" );

            // Print the infix version of the expression.
            System.out.println( AST2infix.ast2infix( ast ) + "\n" );

            // Evaluate the expression (interpret the AST).
            try
            {
               final Value value = Evaluate.eval( ast );
               if (Evaluate.DEBUG > 0)
               {
                  System.out.println("result = " + value + "\n" );
               }
               else
               {
                  System.out.println("result = " + value.toSimpleString() + "\n" );
               }
            }
            catch (EvalException e)
            {
               System.out.println(e);
             //e.printStackTrace();
            }


            // Create dot and png files from the AST.
            if (Evaluate.DEBUG > 0)
            try
            {
               // Create the (empty) dot file.
               final String baseName = String.format("Language_9_2.%02d", i);
               java.io.PrintWriter out = new java.io.PrintWriter(
                                            new java.io.File(baseName + ".dot") );
               // Put dot commands into the dot file
               out.println( Tree2dot.tree2dot(ast) + "\n" );
               out.close();
               // Create a command line for running dot.exe.
               final String[] cmd = {"C:\\graphviz-2.38\\release\\bin\\dot.exe",
                                     "-Tpng",
                                     baseName + ".dot",
                                     "-o",
                                     baseName + ".png"};
               // Execute the command line.
               java.lang.Runtime.getRuntime().exec(cmd);
            }
            catch (Exception e)
            {
               System.out.println( e );
            }
         }
         catch (TokenizeException e)
         {
            System.out.println(e);
          //e.printStackTrace();
         }
         catch (ParseException e)
         {
            System.out.println(e);
          //e.printStackTrace();
         }
      }
   }
}
